/*
 * Minimalizacja funkcji wielu zmiennych ("Projekt systemu")
 * Bartlomiej Brzozowiec, X 2005, Joensuu
 */
//---------------------------------------------------------------------------

#include "GaussSeidel.h"

// konstruktor
GaussSeidel::GaussSeidel() {
        AnsiString nazwa = "met. Gaussa-Seidela";
        Form1->Caption = Form1->FORMCAPTION + " - " + nazwa;
        Form1->Lnazwametody->Caption = nazwa;
}
//---------------------------------------------------------------------------
void GaussSeidel::OKilzm() {
        // pokaz pola na dodatkowe dane
        Form1->Ltau->Visible = true;
        Form1->Etau->Visible = true;
}
//---------------------------------------------------------------------------
bool GaussSeidel::Licz() {
        if( !pobierz_tau() ) return false;
        std::valarray<double> x0 = std::valarray<double>( Form1->WartosciZmiennych, Form1->Ilezm );

        // liczenie minimum
        // (krok jest w tau, poczatkowe wartosci w x0)
        bool end = false;
        double xTbl = 0, xTmp = 0;

        // .K.
        do
        {

                xTbl=WartF(x0);// tu chce wartosc funkcji dla zmiennych haj w tablicy Zmiennych

                for(int i=0; i < Form1->Ilezm;i++)
                {
                        end=false;
                        x0[i]= x0[i]+tau;
                        xTmp=WartF(x0);// tu chce wartosc funkcji dla zmiennych haj w tablicy Zmiennych
                        if (xTmp < xTbl) break; // jak bedzie nizsza to przerwij petle for

                        x0[i]= x0[i]-2*tau;
                        xTmp=WartF(x0);// tu chce wartosc funkcji dla zmiennych haj w tablicy Zmiennych
                        if (xTmp < xTbl) break; // jak bedzie nizsza to przerwij petle for

                        x0[i]= x0[i]+tau;
                        // jak tu doslo bez breaku, to znaczy, ze nie da sie w danym kierunku nic zmienic
                        end=true; // jak przeiteruje wszystkie i i wyjdzie ze statusem end=1 to koniec algorytmu
                }
        }while(!end);

        // teraz w x0[i] mamy wspolzedne minimum
        // a w xTbl wartosc funkcji w minimum, to gdzies trzeba wyswietlic
        // -- .K.
        PokazWynik( x0 );
        return true;
}
//---------------------------------------------------------------------------
void GaussSeidel::Posprzataj() {
        // ukryj pola na dodatkowe dane (analog. jak w OKilzm())
        Form1->Ltau->Visible = false;
        Form1->Etau->Visible = false;
}
//---------------------------------------------------------------------------
bool GaussSeidel::pobierz_tau( void ) {
        AnsiString tmpedtau = Form1->Etau->Text;
        if( tmpedtau == "") {
                Application->MessageBox( "Prosz wypeni tau!", "Bd" );
                Form1->Etau->SetFocus();
                return false;
        }
        try {
                tau = tmpedtau.ToDouble();
        } catch( ... ) {
                Application->MessageBox( "Prosz wpisa poprawn liczb zmiennoprzecinkow (tau)!", "Bd" );
                Form1->Etau->SetFocus();
                return false;
        }

        return true;
}
//---------------------------------------------------------------------------

