/*
 * Minimalizacja funkcji wielu zmiennych ("Projekt systemu")
 * Bartlomiej Brzozowiec, VIII 2005
 */
//---------------------------------------------------------------------------

#include "HookJeeves.h"

// konstruktor
HookJeeves::HookJeeves() {
        AnsiString nazwa = "met. Hooka-Jeevesa";
        Form1->Caption = Form1->FORMCAPTION + " - " + nazwa;
        Form1->Lnazwametody->Caption = nazwa;
}
//---------------------------------------------------------------------------
void HookJeeves::OKilzm() {
        // pokaz pola na dodatkowe dane
        Form1->Ltau->Visible = true;
        Form1->Etau->Visible = true;
        Form1->Lbeta->Visible = true;
        Form1->Ebeta->Visible = true;
        Form1->Lepsilon->Visible = true;
        Form1->Eepsilon->Visible = true;

        // zainicjalizuj i zaalokuj to i owo (sekcja private pliku .h)
        n_wymiar = Form1->Ilezm;

        tau = beta = epsilon = 0.;
        x0.resize(n_wymiar, 0.); // punkt startowy
        d.resize((n_wymiar+1)*n_wymiar, 0.); // n + 1 TYLKO dla wygody indeksowania!!!
        if( ! WpiszWersory( d, n_wymiar+1, n_wymiar ) ) {
                Application->MessageBox( "BD (HookJeeves::OKilzm())! To si nigdy nie powinno zdarzy. KONIEC",
                            "BD!" );
                Form1->Close();
        }
}
//---------------------------------------------------------------------------
bool HookJeeves::Licz() {
        if( !pobierz_t_b_e() ) return false;
        x0 = std::valarray<double>( Form1->WartosciZmiennych, Form1->Ilezm );
        //wypelnij_x0();
        return metoda();
}
//---------------------------------------------------------------------------
void HookJeeves::Posprzataj() {
        // ukryj pola na dodatkowe dane (analog. jak w OKilzm())
        Form1->Ltau->Visible = false;
        Form1->Etau->Visible = false;
        Form1->Lbeta->Visible = false;
        Form1->Ebeta->Visible = false;
        Form1->Lepsilon->Visible = false;
        Form1->Eepsilon->Visible = false;
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
bool HookJeeves::pobierz_t_b_e( void ) {
        AnsiString tmpedtau = Form1->Etau->Text;
        AnsiString tmpedbeta = Form1->Ebeta->Text;
        AnsiString tmpedepsilon = Form1->Eepsilon->Text;
        if( tmpedtau == "" || tmpedbeta == "" || tmpedepsilon == "") {
                Application->MessageBox( "Prosz wypeni wszystkie pola (tau, beta, epsilon)!", "Bd" );
                Form1->Etau->SetFocus(); // XXX todo: sprawdzac, ktore jest puste
                return false;
        }
        try {
                tau = tmpedtau.ToDouble();
                beta = tmpedbeta.ToDouble();
                epsilon = tmpedepsilon.ToDouble();
        } catch( ... ) {
                Application->MessageBox( "Prosz wpisa poprawn liczb zmiennoprzecinkow (tau, beta, epsilon)!", "Bd" );
                Form1->Etau->SetFocus(); // XXX todo: sprawdzac, ktore jest zle
                return false;
        }

        if( beta >= 1 || beta <= 0 ) {
                Application->MessageBox( "Beta musi by z przedziau (0;1).", "Bd" );
                Form1->Ebeta->SetFocus();
                return false;
        }
        // sprawdzac tau w stosunku do epsilon?

        return true;
}
//---------------------------------------------------------------------------
void HookJeeves::wypelnij_x0( void ) { // XXX NIEUZYWANE XXX
        for( int i = 0; i < Form1->Ilezm; i++ )
                x0[i] = Form1->WartosciZmiennych[i];
}
//---------------------------------------------------------------------------
// wlasciwa metoda liczenia minim.
bool HookJeeves::metoda( void ) {
// #define'y sa be?
// (tylko do konca tej funkcji)
#define wiersz_cast( va, indw ) \
  (std::valarray<double>) (va)[std::slice(n_wymiar * (indw), n_wymiar, 1)]
#define wiersz( va, indw ) \
  (va)[std::slice(n_wymiar * (indw), n_wymiar, 1)]

        // przygotuj dodatkowe zmienne
        std::valarray<double> x( 0., (n_wymiar+1)*n_wymiar );
        std::valarray<double> xB0( 0., n_wymiar );
        std::valarray<double> xB( 0., n_wymiar );
        bool cpi;
        int k;
        double q0, q;

        // inicjalizacja (nie wszystkich... czesc nizej)
        wiersz( x,0 ) = x0;
        xB0 = wiersz( x,0 );
        cpi = true;

        // metoda -- glowna petla
        do {
                // etap probny
                // (1)
                k = 0; // a nie k=1, bo zaraz k++
                q0 = WartF( wiersz( x,0 ) );
                do {
                        k++;
                        // (2)
                        wiersz( x,k ) = wiersz_cast( x,k-1 ) + tau*wiersz_cast( d,k );
                        q = WartF( wiersz( x,k ) );
                        // (3)
                        if( q < q0 ) {
                                q0 = q;
                                continue;
                        }
                        // (4)
                        wiersz( x,k ) = wiersz_cast( x,k ) - 2.*tau*wiersz_cast( d,k );
                        q = WartF( wiersz( x,k ) );
                        // (5)
                        if( q < q0 ) {
                                q0 = q;
                                continue;
                        }
                        wiersz( x,k ) = wiersz_cast( x,k-1 );
                } while( k != n_wymiar ); // (6)
                // (7)
                if( WartF( xB0 ) > WartF( wiersz( x,k ) ) ) {
                        xB = wiersz( x,k );
                        // etap roboczy
                        wiersz( x,0 ) = 2.*xB - xB0; // (1)
                        xB0 = xB; // (2)

                        cpi = false;
                } else {
                        if( cpi ) {
                                Application->MessageBox( "Zmie punkt startowy.", "Komunikat metody" );
                                //break;
                                return false;
                        } else {
                                wiersz( x,0 ) = xB0;
                                tau = beta*tau;
                                // kryterium zbieznosci:
                                if( tau < epsilon ) {
                                        PokazWynik( xB0 );
                                        //break;
                                        return true;
                                }
                        }
                }
        } while( true ); // petla nieskonczona

        return true; // nie dochodzi
#undef wiersz
#undef wiersz_cast
}
//---------------------------------------------------------------------------

