/*
 * Minimalizacja funkcji wielu zmiennych ("Projekt systemu")
 * Bartlomiej Brzozowiec, VIII 2005, B-m
 */
//---------------------------------------------------------------------------

#include "MetodaMinim.h"
#include "Unit1.h"

/* wpisuje do valarray (traktowanego jak dwuwymiarowa tablica) ortogonalne wektory
 * jednostkowe; a zatem tablica musi byc kwadratowa; dopuszczony jest jednak
 * przypadek, gdy 'wysokosc' (ilosc wierszy) jest o jeden wieksza niz 'szerokosc'
 * (ilosc kolumn); wtedy w pierwszym wierszu pozostaja zera, a wersorami jest
 * wypelniona reszta tablicy;
 * zwraca false w razie blednych danych wejsciowych, true jesli OK */
// zakomentowane to i owo, bo byly problemy z linkowaniem...
//template<class T>
//bool MetodaMinim::WpiszWersory( std::valarray<T>& va, int ile_wierszy, int ile_kolumn ) {
bool MetodaMinim::WpiszWersory( std::valarray<double>& va, int ile_wierszy, int ile_kolumn ) {
        if( ile_wierszy*ile_kolumn > va.size() ||
            ile_wierszy < 1 ||
            ile_kolumn < 1 ||
            (ile_wierszy != ile_kolumn && ile_wierszy != ile_kolumn + 1) )
                return false;

        //va = (T) 0;
        va = 0.;

        int tmp = (ile_wierszy == ile_kolumn ? 0 : 1);
        for( int indw = 0; indw < ile_kolumn; indw++ )
                va[ ile_kolumn*(indw+tmp) + indw ] = 1.;
                //va[ ile_kolumn*(indw+tmp) + indw ] = (T) 1;

        return true;
}
//---------------------------------------------------------------------------
// zwraca wart. f. w punkcie; korzysta z zewn. zrodel...
double MetodaMinim::WartF( const std::valarray<double>& va ) {
        for( int i = 0; i < Form1->Ilezm; i++ )
                Form1->WartosciZmiennych[i] = va[i];
        double wart = Form1->ParserWyr.WartoscWyrazenia();
        // XXX
        // kontrola bledow (na podst. Win-zRTL\Unit1.cpp)
        if( Form1->ParserWyr.OpisBledu ) {
                Form1->SBopbl->SimpleText = "BD PARSERA WYRAE ARYTMETYCZNYCH (runtime): "
                                        + AnsiString( Form1->ParserWyr.OpisBledu );
                //ShowMessage( "BD PARSERA WYRAE ARYTMETYCZNYCH (runtime): "
                //                        + AnsiString( ParserWyr.OpisBledu ) );
                Form1->Lwartf->Caption = "ERR";
        }
        //Form1->Lwartf->Caption = AnsiString( wart ); // XXX
        return wart;
}
//---------------------------------------------------------------------------
void MetodaMinim::PokazWynik( const std::valarray<double>& va ) {
        double wart = WartF( va );
        AnsiString tmp, tmp2 = "f( ";
        /* AnsiString tmp = "f( ";
        for( int i = 0; i < Form1->Ilezm; i++ )
                tmp += AnsiString( va[i] ) + (i == Form1->Ilezm - 1 ? " ) = " : ", " ); */
        for( int i = 0; i < Form1->Ilezm; i++ ) {
                tmp += "x" + AnsiString( i + 1 ) + " = " + AnsiString( va[i] ) + "\n";
                tmp2 += "x" + AnsiString( i + 1 ) + (i == Form1->Ilezm - 1 ? " ) = " : ", " );
        }
        tmp += tmp2;

        Form1->Lwynik->Caption = "wynik:\n" + tmp + AnsiString( wart );
        Form1->Lwynik->Visible = true;
        Form1->Lwartf->Caption = AnsiString( wart );
}
//---------------------------------------------------------------------------

