/*
 * Minimalizacja funkcji wielu zmiennych ("Projekt systemu")
 * Bartlomiej Brzozowiec, VII 2005, Kopina
 */
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
// dodalem (dodac tez w Project Managerze  satorparser.lib):
#include "satorparserv_use.h"
#include <stdio.h>      // FILE, ...
#include <StrUtils.hpp> // AnsiReplaceStr()

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner),
        // stale
        // int:
        TOPLAB(120),
        TOPED(120),
        OFFLEFTLAB(32),
        OFFLEFTED(48),
        PRZERWAILABWIDTH(20),
        WIDTHED(70),
        HEIGHTED(21),
        // double:
        DEFAULTSTARTVAL(0.0),
        // AnsiString:
        FORMCAPTION("Minimalizacja funkcji wielu zmiennych"),
        // const char * const:
        GNUPLOT_PATH("wgnuplot\\wgnuplot.exe")
{
        DecimalSeparator = '.';

        ParserNazwyZmiennych = NULL;
        ParserAdresyZmiennych = NULL;
        WartosciZmiennych = NULL;

        Edynx = NULL;

        Ilezm = 0;
        Metoda_ptr = NULL;

        HookaJeevsa1Click( this );
}
//---------------------------------------------------------------------------

void __fastcall TForm1::EilzmNaKlawiszNacis(TObject *Sender, char &Key)
{
        if( isdigit( Key ) || Key == '\r' || Key == '\b' || Key == VK_ESCAPE )
                return;
        else
                Key = NULL;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::EilzmNaKlawiszDol(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
        if( Key == '\r' ) {
                BokilzmClick( this );
        } else if( Key == VK_ESCAPE ) {
                Close();
        }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BokilzmClick(TObject *Sender)
{
        if( Eilzm->Text == "" || Eilzm->Text.ToInt() == 0 )
                return;

        Ilezm = Eilzm->Text.ToInt(); // !!! tu ustawiamy  Ilezm  !!!
        // pokaz do tej pory niewidoczne obiekty
        Lfop->Visible = true;
        Lznrown->Visible = true;
        Ef->Visible = true;
        Ef->SetFocus();
        Blicz->Visible = true;
        if( Ilezm == 1 || Ilezm == 2 ) {
                Bprzyklad->Visible = true;
                Brysujwykres->Visible = true;
        }
        // wylacz obiekty zwiazane z podawaniem ilosci zmiennych niezaleznych
        Eilzm->Enabled = false;
        Bokilzm->Enabled = false;

        // UWAGA: nizej duzo  new  , pamietac o  delete  !!!
        // (XXX todo: sprawdzac wszedzie, czy alokacja pamieci sie powiodla (new  zwraca NULL, jesli sie nie udalo...))
        ParserPrzygotujAdresyZmiennych();
        ParserNazwyZmiennych = new char*[Ilezm];
        Edynx = new TEdit*[Ilezm]; // potrzebna tablica, zeby moc sie pozniej latwo odwolac do wpisanych wartosci
        AnsiString tmp = "f( ";
        for( int i = 1; i <= Ilezm; i++ ) {
                AnsiString zmienna = "x" + AnsiString( i );
                tmp += zmienna + (i == Ilezm ? " ) = " : ", " );
                // wypelnienie tablicy z nazwami zmiennych dla parsera
                ParserNazwyZmiennych[i-1] = new char[zmienna.Length() + 1]; // +1 na NULL
                strcpy( ParserNazwyZmiennych[i-1], zmienna.c_str() );

                // tworzenie dynamiczne pol i opisow zmiennych
                // (Labele na dluzsza mete anonimowe, Edity -- w tablicy)
                TLabel *lzmop = new TLabel( this );
                lzmop->Parent = this;
                lzmop->Left = OFFLEFTLAB + (i-1)*(PRZERWAILABWIDTH+WIDTHED);
                lzmop->Top = TOPLAB;
                lzmop->Caption = zmienna + ":";

                Edynx[i-1] = new TEdit( this );
                Edynx[i-1]->Parent = this;
                Edynx[i-1]->Text = AnsiString( DEFAULTSTARTVAL );
                Edynx[i-1]->Left = OFFLEFTED + (i-1)*(PRZERWAILABWIDTH+WIDTHED);
                Edynx[i-1]->Top = TOPED;
                Edynx[i-1]->Width = WIDTHED;
                Edynx[i-1]->Height = HEIGHTED;
                Edynx[i-1]->OnKeyDown = EdynxNaKlawiszDol;
                Edynx[i-1]->OnKeyPress = EdynxNaKlawiszNacis;
        }
        Lfop->Caption = tmp;

        // *** TU TWORZENIE DODATKOWYCH POL NA DODATKOWE DANE DLA KONKRETNEJ METODY MINIM.
        // I INNE (alokacja zasobow, etc.)
        Metoda_ptr->OKilzm();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BliczClick(TObject *Sender)
{
        if( !ParserWypelnijAdresyZmiennych() ) return;
        if( !ParserParsuj() ) return;
        if( !ParserPokazWartosc() ) return;

        //Ef->OnKeyDown = NULL; // zeby zapewnic, ze ta funkcja jest wywolana tylko na samym poczatku
        //Blicz->Enabled = false;
        //Ef->Enabled = false;
        Bodnowa->Visible = true;
        /*for( int i = 0; i < Ilezm; i++ )
                Edynx[i]->Enabled = false;*/
        // *** TU (?) POBRANIE DODATKOWYCH DANYCH DLA DZIALANIA KONKRETNEJ MET. MIN.
        // *** TU START DZIALANIA METODY MINIM. *** (cos mozna jeszcze powylaczac (usunac calkowicie przycisk "Od nowa"?))
        // *** TU WYPISANIE ROZWIAZANIA
        Metoda_ptr->Licz();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::EfNaKlawiszNacis(TObject *Sender, char &Key)
{
        /*if( isdigit( Key ) || Key == '\r' || Key == '\b' || Key == VK_ESCAPE ||
              Key == '.' )
                return;
        else
                Key = NULL;*/
}
//---------------------------------------------------------------------------
void __fastcall TForm1::EfNaKlawiszDol(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
        if( Key == '\r' ) {
                BliczClick( this );
        } else if( Key == VK_ESCAPE ) {
                Close();
        }
}
//---------------------------------------------------------------------------
// UWAGA: nie tylko Edynx korzystaja z dwoch ponizszych metod!!!
void __fastcall TForm1::EdynxNaKlawiszNacis(TObject *Sender, char &Key) {
        if( isdigit( Key ) || Key == '\r' || Key == '\b' || Key == VK_ESCAPE ||
              Key == '.' || Key == '-' )
                return;
        else
                Key = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::EdynxNaKlawiszDol(TObject *Sender, WORD &Key,
      TShiftState Shift) {
        if( Key == '\r' )
                BliczClick( this );
}
//---------------------------------------------------------------------------
void TForm1::ParserPrzygotujAdresyZmiennych( void ) {
        // pamietaj: po NEW -- DELETE!!!
        ParserAdresyZmiennych = new double*[Ilezm];
        // osobna tablica na trzymanie wartosci
        // (w ParserAdresyZmiennych sa tylko ich adresy)
        WartosciZmiennych = new double[Ilezm];
        for( int i = 0; i < Ilezm; i++ ) {
                // wstepnie wypelniamy DEFAULTSTARTVAL
                WartosciZmiennych[i] = DEFAULTSTARTVAL;
                ParserAdresyZmiennych[i] = &WartosciZmiennych[i];
        }
}

// zwraca false w razie bledu (np. zlych danych...), true gdy OK
bool TForm1::ParserWypelnijAdresyZmiennych( void ) {
        for( int i = 0; i < Ilezm; i++ ) {
                AnsiString tmped = Edynx[i]->Text;
                if( tmped == "" ) {
                        ShowMessage( "Prosz wypeni wszystkie pola!" );
                        Edynx[i]->SetFocus();
                        return false;
                }
                try {
                        double val = tmped.ToDouble();
                        WartosciZmiennych[i] = val;
                } catch( ... ) {
                        ShowMessage( "Prosz wpisa poprawn liczb zmiennoprzecinkow!" );
                        Edynx[i]->SetFocus();
                        return false;
                }
        }
        return true;
}

// zwraca false w razie problemu z wyrazeniem, true gdy OK
bool TForm1::ParserParsuj( void ) {
        ParserWyr.Parsuj( Ilezm,
                          (const char **) ParserNazwyZmiennych,
                          (const double **) ParserAdresyZmiennych,
                          Ef->Text.c_str() );
        // kontrola bledow (na podst. UnitWyr.cpp z wykresy-s)
        if( ParserWyr.OpisBledu ) {
                AnsiString komunikat = "BD PARSERA WYRAE ARYTMETYCZNYCH: " + AnsiString( ParserWyr.OpisBledu );
                SBopbl->SimpleText = komunikat;
                if( ParserWyr.GSB ) {
                        // += tu nie dziala...
                        SBopbl->SimpleText = SBopbl->SimpleText + " (bd: " + AnsiString( ParserWyr.GSB ) + ")";
                        komunikat += " (bd: " + AnsiString( ParserWyr.GSB ) + ")";
                }
                ShowMessage( komunikat );
                Ef->SetFocus();
                return false;
        } else
                SBopbl->SimpleText = "wyraenie OK";

        return true;
}

// zwraca false w razie bledu (np. dzielenia przez 0, za duzych wart. silni, itp.),
// true gdy OK
bool TForm1::ParserPokazWartosc( void ) {
        double wart = ParserWyr.WartoscWyrazenia();
        // kontrola bledow (na podst. Win-zRTL\Unit1.cpp)
        if( ParserWyr.OpisBledu ) {
                SBopbl->SimpleText = "BD PARSERA WYRAE ARYTMETYCZNYCH (runtime): "
                                        + AnsiString( ParserWyr.OpisBledu );
                ShowMessage( "BD PARSERA WYRAE ARYTMETYCZNYCH (runtime): "
                                        + AnsiString( ParserWyr.OpisBledu ) );
                Lwartf->Caption = "ERR";
                return false;
        }
        Lwartf->Visible = true;
        Lwartf->Caption = AnsiString( wart );
        return true;
}


void TForm1::ParserPosprzataj( void ) {
        // z ParserPrzygotujAdresyZmiennych()
        if( WartosciZmiennych ) {
                delete [] WartosciZmiennych;
                WartosciZmiennych = NULL;
        }

        if( ParserAdresyZmiennych ) {
                delete [] ParserAdresyZmiennych;
                ParserAdresyZmiennych = NULL;
        }

        // z BokilzmClick()
        if( ParserNazwyZmiennych ) {
                for( int i = 0; i < Ilezm; i++ ) {
                        delete [] ParserNazwyZmiennych[i];
                        ParserNazwyZmiennych[i] = NULL;
                }
                delete [] ParserNazwyZmiennych;
                ParserNazwyZmiennych = NULL;
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BodnowaClick(TObject *Sender)
{
        // *** TA METODE WYWOLUJEMY PRZY WYBORZE KONKRETNEJ METODY MINIM.
        // PAMIETAJ, ZE TA MET. MOZE BYC WYWOLANA TAKZE WTEDY, GDY _NIE MA_ WYSWIETLONYCH WSZYSTKICH ELEMENTOW
        // (DECYDUJEMY NA PODST. Ilezm/Metoda_ptr)
        // zniknij/wlacz co trzeba
        if( Metoda_ptr ) {
                Lfop->Visible = false;
                Lznrown->Visible = false;
                Ef->Visible = false;
                Ef->Text = "";
                Blicz->Visible = false;

                if( Ilezm == 1 || Ilezm == 2 ) {
                        Bprzyklad->Visible = false;
                        Brysujwykres->Visible = false;
                }

                Eilzm->Enabled = true;
                Bokilzm->Enabled = true;

                //Blicz->Enabled = true; // XXX
                Bodnowa->Visible = false;
                Lwartf->Visible = false;
                Lwynik->Caption = "";
                Lwynik->Visible = false;

                ParserPosprzataj(); // zwolnienie pamieci

                if( Edynx ) {
                        for( int i = 0; i < Ilezm; i++ )
                                delete Edynx[i];
                        delete [] Edynx;
                        Edynx = NULL;
                }

                // wyczyszczenie labeli (x<nr>)
                for( int i = 0; i < Ilezm; i++ )
                        delete Components[ComponentCount-1];
                Eilzm->SetFocus();
                SBopbl->SimpleText = "";

                Metoda_ptr->Posprzataj();

                Ilezm = 0; // NA SAMYM KONCU, NIE WCZESNIEJ!
        } // .. Metoda_ptr
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Koniec1Click(TObject *Sender)
{
        Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Oprogramie1Click(TObject *Sender)
{
        MessageBox( Handle,
                    "Minimalizacja funkcji wielu zmiennych\n\n"
                    "Bartomiej Brzozowiec, 2005\n"
                    "(program wykorzystuje bibliotek do obliczania wartoci wyrae arytmetycznych "
                    "satorparserv autorstwa Artura Czekalskiego (Satora) oraz gnuplota do tworzenia wykresw)", // tekst okienka
                    "O programie", // tytul okienka
                    MB_OK | MB_ICONINFORMATION ); // przycisk i ikona
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Pomocdoparserawyraearytmetycznych1Click(
      TObject *Sender)
{
        // na podst. wykresy-s\Unit01.cpp
        WinHelp( Handle, "WYRAZENIA.HLP", HELP_CONTENTS, 0 );
}
//---------------------------------------------------------------------------

void __fastcall TForm1::HookaJeevsa1Click(TObject *Sender)
{
        BodnowaClick( this );
        if( Metoda_ptr ) {
                delete Metoda_ptr;
                Metoda_ptr = NULL;
        }
        Metoda_ptr = new HookJeeves;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BprzykladClick(TObject *Sender)
{
        static size_t ind = 0;

        size_t przwykr3d_ilosc = 3;
        AnsiString przwykr3d[] = {
                        "-exp(-(x1^2+x2^2))",
                        "-exp(-((0.1*x1)^2+(0.3*x2)^2))",
                        "-sin(sqrt(x1^2+x2^2))/sqrt(x1^2+x2^2)",
                                 };

        size_t przwykr2d_ilosc = 4;
        AnsiString przwykr2d[] = {
                                "sin(x1)",
                                "x1*cos(x1)",
                                "-sin(abs(x1))/abs(x1)",
                                "x1^2*sin(x1)",
                                 };

        if( Ilezm == 1 ) {
                if( ind >= przwykr2d_ilosc )
                        ind = 0;
                Ef->Text = przwykr2d[ind];
                ind++;
        } else if( Ilezm == 2 ) {
                if( ind >= przwykr3d_ilosc )
                        ind = 0;
                Ef->Text = przwykr3d[ind];
                ind++;
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BrysujwykresClick(TObject *Sender)
{
        // sprawdzmy najpierw, czy funkcja jest sensowna
        if( !ParserParsuj() ) return;

        // XXX przerobic to i owo na try/catch/throw?

        const AnsiString tmpfn = GimmeTmpFileName();
        //Caption = tmpfn; // debug
        if( tmpfn == "ERROR" ) return;
        // UWAGA: od tego momentu istnieje juz plik tymczasowy na dysku (az do wykasowania, oczywiscie)

        if( ! PrepareFileForGnuplot( tmpfn ) ) {
                // usun plik tymczasowy
                if( ! DeleteFile( tmpfn.c_str() ) )
                        ShowMessage( "Problem z usunieciem pliku tymczasowego (" + tmpfn + ")!" );
                return;
        }
        //Sleep( 200 ); // XXX
        RunProgram( GNUPLOT_PATH, (tmpfn + " -").c_str() );
        Sleep( 900 ); // za szybkie usuniecie powoduje niemoznosc narysowania wykresu XXX
        // usun plik tymczasowy
        if( ! DeleteFile( tmpfn.c_str() ) )
                ShowMessage( "Problem z usunieciem pliku tymczasowego (" + tmpfn + ")!" );
}
//---------------------------------------------------------------------------
// zwraca "ERROR" w razie bledu
AnsiString TForm1::GimmeTmpFileName( void ) {
        // na podst. http://msdn.microsoft.com/library/default.asp?url=/library/en-us/fileio/fs/creating_and_using_a_temporary_file.asp
        const size_t myBufSize = 65536;

        DWORD dwRetVal;
        DWORD dwBufSize = myBufSize;
        UINT uRetVal;
        char szTempName[myBufSize];
        char lpPathBuffer[myBufSize];

        // Get the temp path.
        dwRetVal = GetTempPath( dwBufSize,      // length of the buffer
                                lpPathBuffer ); // buffer for path
        if( dwRetVal > dwBufSize || dwRetVal == 0 ) {
                //MyFormatMessage();//debug
                // WORKAROUND (problem w WinXP...)
                return "gplottmp";
                //ShowMessage( "Problem z uzyskaniem nazwy katalogu na pliki tymczasowe (GimmeTmpFileName())!" );
                //return "ERROR";
        }

        // Create a temporary file.
        uRetVal = GetTempFileName( lpPathBuffer,        // directory for tmp files
                                   "min",               // temp file name prefix
                                   0,                   // create unique name
                                   szTempName );        // buffer for name
        if( uRetVal == 0 ) {
                ShowMessage( "Problem z tworzeniem pliku tymczasowego w katalogu \""
                                + AnsiString( lpPathBuffer ) + "\" (GimmeTmpFileName())!" );
                return "ERROR";
        }

        return AnsiString( szTempName );
}
//---------------------------------------------------------------------------
// zwraca false w razie bledu, true gdy OK
bool TForm1::PrepareFileForGnuplot( AnsiString tmpf ) {
        FILE *fp;
        fp = fopen( tmpf.c_str(), "w" );
        if( ! fp ) {
                ShowMessage( "Problem z otwarciem do dopisywania pliku tymczasowego \"" + tmpf + "\" (PrepareFileForGnuplot())!" );
                return false;
        }

        // ----
        AnsiString funkcja = SatorparserToGnuplot( Ef->Text );
        // wykresy 2-D lepiej zostawic z range'ami domyslnymi?
        // TODO(?): dorobic parametry konfigurowalne i/lub dodac  set pm3d  w 3D
        // XXX TODO: walidacja granic przedzialow wykresu...
        fprintf( fp, "set title \"Wykres funkcji %d-D  (klawisze \\\"q\\\" i \\\"w\\\" zmieniaj granice przedziaw)\"\n"
                     "set contour\n"
                     "set isosamples 30\n"
                     "%s\n"
                     "xrmin = %s\n"
                     "xrmax = %s\n"
                     "yrmin = %s\n"
                     "yrmax = %s\n"
                     "bind q \" \\\n"
                     "  xrmin = xrmin - 0.5; \\\n"
                     "  xrmax = xrmax + 0.5; \\\n"
                     "  yrmin = yrmin - 0.5; \\\n"
                     "  yrmax = yrmax + 0.5; \\\n"
                     "  set xrange [xrmin:xrmax]; \\\n"
                     "  set yrange [yrmin:yrmax]; \\\n"
                     "  replot \\\n"
                     "  \"\n"
                     "bind w \" \\\n"
                     "  xrmin = xrmin + 0.5; \\\n"
                     "  xrmax = xrmax - 0.5; \\\n"
                     "  yrmin = yrmin + 0.5; \\\n"
                     "  yrmax = yrmax - 0.5; \\\n"
                     "  set xrange [xrmin:xrmax]; \\\n"
                     "  set yrange [yrmin:yrmax]; \\\n"
                     "  replot \\\n"
                     "  \"\n"
                     "%splot [xrmin:xrmax] [yrmin:yrmax] %s\n",
                     Ilezm + 1,
                     Ilezm == 1 ? "set zeroaxis" : "",
                     Form2->Edit1->Text.c_str(),
                     Form2->Edit2->Text.c_str(),
                     Form2->Edit3->Text.c_str(),
                     Form2->Edit4->Text.c_str(),
                     Ilezm == 1 ? "" : Ilezm == 2 ? "s" : "",
                     funkcja.c_str() );
        // ----

        if( fclose( fp ) != 0 ) {
                ShowMessage( "Problem z zamknieciem pliku tymczasowego \"" + tmpf + "\" (PrepareFileForGnuplot())!" );
                return false;
        }

        /*
        // !!!!!!!!! tylko DEBUG !!!!!!!!!!!!!!
        Memo1->Text = Memo1->Text + "(" + tmpf + ":)\r\n";
        fp = fopen( tmpf.c_str(), "r" );
        if(!fp){Caption="ERRORdebug";return false;}
        char buf[1024*10];
        while(fgets(buf, 1024*10-1, fp)) {
                if( buf[strlen(buf)-1] == '\n' ) buf[strlen(buf)-1] = '\0';
                Memo1->Text = Memo1->Text + AnsiString(buf) + "\r\n"; // \r\n !!!!!!!!!
        }
        Memo1->Text = Memo1->Text + "-----------------------------\r\n";
        if(fclose(fp)!=0){Caption="ERRORdebug-close";return false;}
        // !!!!!!!!! tylko DEBUG - koniec !!!!!
        */

        return true;
}
//---------------------------------------------------------------------------
AnsiString TForm1::SatorparserToGnuplot( AnsiString parserstring ) {
        AnsiString ret;

        ret = AnsiReplaceStr( parserstring, "^", "**" );
        // ew. if Ilezm ..:
        ret = AnsiReplaceStr( ret, "x1", "x" );
        ret = AnsiReplaceStr( ret, "x2", "y" );
        // ...

        return ret;
}
//---------------------------------------------------------------------------
// na podst. http://groups.google.pl/group/borland.public.cppbuilder.language/browse_thread/thread/c6847aa2c7d5dd21/dc47db54c3ca2b0d?lnk=st&q=example+calling+%22external+program%22+borland+builder&rnum=3&hl=pl#dc47db54c3ca2b0d
// f. zwraca 0 w razie bledu
int TForm1::RunProgram(const char * const progname, const char * const parameters)
{
    SHELLEXECUTEINFO execinfo;
    memset( &execinfo, 0, sizeof(execinfo) );
    execinfo.cbSize = sizeof(execinfo);
    execinfo.lpVerb = "open";
    execinfo.lpFile = progname;
    execinfo.fMask = SEE_MASK_NOCLOSEPROCESS;
    execinfo.nShow = SW_SHOWDEFAULT;
    execinfo.lpParameters = parameters;

    /*if(strcmp(state,"normal")==0)
        execinfo.nShow=SW_SHOWDEFAULT;
    else
        execinfo.nShow=SW_MAXIMIZE;*/

    if (! ShellExecuteEx( &execinfo ) )
    {
        ShowMessage( "Nie mona uruchomi zewntrznego programu \""
                     + AnsiString( progname ) + " "
                     + AnsiString( parameters ) +  "\"" );
        return 0;
    }

    /*Application->Minimize();     // this minimizes the calling app
    WaitForSingleObject( execinfo.hProcess, INFINITE );
    Application->Restore();      // this restores it*/
    //return execinfo.hProcess; // zmien tez wartosc zwracana na HANDLE
    return 1;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PomocGnuplota1Click(TObject *Sender)
{
        WinHelp( Handle, "wgnuplot\\wgnuplot.hlp", HELP_CONTENTS, 0 );
}
//---------------------------------------------------------------------------
// debug
void TForm1::MyFormatMessage( void )
{
        LPVOID lpMsgBuf;

        FormatMessage(
            FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
            NULL,
            GetLastError(),
            MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
            (LPTSTR) &lpMsgBuf,
            0,
            NULL
        );

        // Display the string.
        MessageBox( NULL, (const char*) lpMsgBuf, "GetLastError", MB_OK|MB_ICONINFORMATION );

        // Free the buffer.
        LocalFree( lpMsgBuf );
}
//---------------------------------------------------------------------------



void __fastcall TForm1::Opcjewykresu1Click(TObject *Sender)
{
        Form2->Show();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::GaussaSeidla1Click(TObject *Sender)
{
        BodnowaClick( this );
        if( Metoda_ptr ) {
                delete Metoda_ptr;
                Metoda_ptr = NULL;
        }
        Metoda_ptr = new GaussSeidel;
}
//---------------------------------------------------------------------------

