/*
 * Minimalizacja funkcji wielu zmiennych ("Projekt systemu")
 * Bartlomiej Brzozowiec, VII 2005, Kopina
 */
//---------------------------------------------------------------------------

#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>

// dodalem:
#include "satorparserv_use.h"
#include "MetodaMinim.h"
#include "HookJeeves.h"
#include "GaussSeidel.h"

#include <Menus.hpp>
//---------------------------------------------------------------------------

class TForm1 : public TForm
{
__published:	// IDE-managed Components
        TStatusBar *SBopbl;
        TLabel *Lilzm;
        TEdit *Eilzm;
        TButton *Bokilzm;
        TLabel *Lfop;
        TEdit *Ef;
        TLabel *Lznrown;
        TButton *Blicz;
        TLabel *Lwartf;
        TButton *Bodnowa;
        TMainMenu *MainMenu1;
        TMenuItem *Plik1;
        TMenuItem *Koniec1;
        TMenuItem *Metoda1;
        TMenuItem *HookaJeevsa1;
        TMenuItem *Pomoc1;
        TMenuItem *Oprogramie1;
        TMenuItem *Pomocdoparserawyraearytmetycznych1;
        TLabel *Lnazwametody;
        TLabel *Ltau;
        TEdit *Etau;
        TLabel *Lbeta;
        TEdit *Ebeta;
        TLabel *Lepsilon;
        TEdit *Eepsilon;
        TLabel *Lwynik;
        TButton *Bprzyklad;
        TButton *Brysujwykres;
        TMenuItem *N1;
        TMenuItem *PomocGnuplota1;
        TMenuItem *Opcje1;
        TMenuItem *Opcjewykresu1;
        TMenuItem *GaussaSeidla1;
        void __fastcall EilzmNaKlawiszNacis(TObject *Sender, char &Key);
        void __fastcall EilzmNaKlawiszDol(TObject *Sender, WORD &Key,
          TShiftState Shift);
        void __fastcall BokilzmClick(TObject *Sender);
        void __fastcall BliczClick(TObject *Sender);
        void __fastcall EfNaKlawiszNacis(TObject *Sender, char &Key);
        void __fastcall EfNaKlawiszDol(TObject *Sender, WORD &Key,
          TShiftState Shift);
        void __fastcall BodnowaClick(TObject *Sender);
        void __fastcall Koniec1Click(TObject *Sender);
        void __fastcall Oprogramie1Click(TObject *Sender);
        void __fastcall Pomocdoparserawyraearytmetycznych1Click(
          TObject *Sender);
        // zdarzenia dla dynamicznie stworzonych pol edycyjnych I NIE TYLKO
        void __fastcall EdynxNaKlawiszNacis(TObject *Sender, char &Key);
        void __fastcall EdynxNaKlawiszDol(TObject *Sender, WORD &Key,
          TShiftState Shift);
        void __fastcall HookaJeevsa1Click(TObject *Sender);
        void __fastcall BprzykladClick(TObject *Sender);
        void __fastcall BrysujwykresClick(TObject *Sender);
        void __fastcall PomocGnuplota1Click(TObject *Sender);
        void __fastcall Opcjewykresu1Click(TObject *Sender);
        void __fastcall GaussaSeidla1Click(TObject *Sender);
private:	// User declarations
        // funkcje zw. z parserem (wrappery - obsluga bledow etc...)
        // UWAGA: _MUSI_ byc juz ustawiona zm. Ilezm przed wywolaniem f. 1!!!
        void ParserPrzygotujAdresyZmiennych( void ); // 1
        bool ParserWypelnijAdresyZmiennych( void ); // 2
        bool ParserParsuj( void );// 3
        bool ParserPokazWartosc( void );// 4
        void ParserPosprzataj( void );// zwalnia zasoby (czesc z nich alokowana w BokilzmClick())
        // tablica dynamicznie stworzonych pol na wartosci poczatkowe
        TEdit **Edynx;

        // wskaznik do abstrakcyjnej klasy, po ktorej dziedzicza metody minim.
        MetodaMinim *Metoda_ptr;

        // inne
        // stale
        const int TOPLAB, TOPED, OFFLEFTLAB, OFFLEFTED, PRZERWAILABWIDTH, WIDTHED,
                HEIGHTED;
        const double DEFAULTSTARTVAL;

        // metody i zmienne zwiazane z obsluga Gnuplota
        int RunProgram(const char * const progname, const char * const parameters);
        AnsiString GimmeTmpFileName( void );
        bool PrepareFileForGnuplot( AnsiString tmpf );
        AnsiString SatorparserToGnuplot( AnsiString parserstring );
        //debug
        void MyFormatMessage( void );
        // stale
        const char * const GNUPLOT_PATH;
public:		// User declarations
        __fastcall TForm1(TComponent* Owner);
        // moje (korzystaja z tego w klasach - metodach minim.)
        int Ilezm; // ilosc zmiennych niezaleznych
        // zmienne dla parsera
        ObliczanieWyrazenia ParserWyr;
        char **ParserNazwyZmiennych;
        double **ParserAdresyZmiennych;
        double *WartosciZmiennych; // zakres waznosci taki jak ParserAdresyZmiennych (powiazane...)
        // stale
        const AnsiString FORMCAPTION;
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
